;͸
;                                                                           
; (c) 1996 by Marc van Shaney , aka Kaya Memisoglu                          
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;        Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza             
;                                                                           
;                                                                           
;;

;
;

;   GOMEZ MUSIC INTERFACE                                   EXAMPLE-PROGGY

;
;
P486
LOCALS
JUMPS

CODE32	SEGMENT PARA PUBLIC USE32
	ASSUME CS:CODE32, DS:CODE32
	largestack

INCLUDE gomez.inc
INCLUDE gmi32.inc
INCLUDE devices.inc
INCLUDE keys.inc

stxt		DB	"Gomez Music Interface                               (C) 1996 by Marc van Shaney",10,13,'$'
stxt1		DB	"ENTER EXIT to return . . .",10,13,'$'
etxt0		DB	"Usage: APLAY.EXE [module.XM]",10,13,'$'
etxt1		DB	"Error: Could NOT load module . . .",10,13,'$'
etxt2		DB	"Error: Could NOT initialize music system.",10,13,'$'
etxt3		DB	"Error: No sound card etected.",10,13,'$'
dos_command     DB      "C:\COMMAND.COM",0
dos_switches    DB      0
dos_parameter   DW      0
		DW      SMALL OFFSET dos_switches
		DW      SEG dos_switches
		DW      5Ch
dos_fcb1        DW      ?
		DW      6Ch
dos_fcb2        DW      ?
shandle		DD	?
tilde		DB	"~",0
;
PUBLIC C MAIN
MAIN PROC NEAR
	MOV	ESI,OFFSET stxt
	CALL	Print32
	MOV	EAX,OFFSET tilde
	CALL    Scan_Argument
	JC	ERR0
	MOV	ESI,EAX
	;
	;
	; Try to detect the best hardware available. The order is:
	;	GUS
	;	SB-DMA
	;	SB-Timer
	;	AdLib
	;	PC-Speaker
	;
	CALL	DWORD PTR DS:[GUS_Driver+40]
	MOV	EAX,OFFSET GUS_Driver
	JNC	SHORT @@DOIT
	CALL	DWORD PTR DS:[SBDMA_Driver+40]
	MOV	EAX,OFFSET SBDMA_Driver
	JNC	SHORT @@DOIT
	JMP	ERR3
	;
@@DOIT: MOV	EBX,GMI_USE_STEREO OR GMI_USE_16BIT
	MOV	ECX,46000
	CALL	Init_GMI
	JC	ERR2
	MOV	EBX,ESI				;EBX = ptr to file-name
	XOR	EDX,EDX				;Start at file offset 0
	CALL	GMI_Load_Song			;Load module
	JC	ERR1
	MOV	DS:[shandle],EAX
	CALL	GMI_Play_Song
	JC	ERR2
	;
	MOV	ESI,OFFSET stxt1
	CALL	Print32

	MOV 	EBX,DS:[PSP_Address]           	;Get PSP
	MOV 	DS:[dos_fcb1],BX
	MOV 	DS:[dos_fcb2],BX

	MOV	DS:[v86_DS],SEG CODE32
	MOV	DS:[v86_ES],SEG CODE32
	MOV 	DS:[v86_edx],OFFSET dos_command
	MOV 	DS:[v86_ebx],OFFSET dos_parameter
	MOV 	DS:[v86_eax],4B00h
	MOV	EAX,21h
	CALL	Invoke_real_int
	;
@@END:	CALL	GMI_Stop_Song
	MOV	EAX,DS:[shandle]
	CALL 	GMI_Free_Song
	CALL	Exit_GMI
	JMP	Exit_PMODE32
;
ERR0:	MOV	ESI,OFFSET etxt0		;Display error-text
	CALL	Print32
	JMP	Exit_PMODE32
	;
ERR1:	MOV	ESI,OFFSET etxt1		;Display error-text
	CALL	Print32
	JMP	Exit_PMODE32
	;
ERR2:	MOV	ESI,OFFSET etxt2		;Display error-text
	CALL	Print32
	JMP	Exit_PMODE32
	;
ERR3:	MOV	ESI,OFFSET etxt3		;Display error-text
	CALL	Print32
	JMP	Exit_PMODE32
	;

MAIN ENDP
CODE32 ENDS
END
