
;͸
;                                                                           
; (c) 1996 by Marc van Shaney , aka Kaya Memisoglu                          
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;        Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza             
;                                                                           
;                                                                           
;;
;
P486
LOCALS
JUMPS

;
;
;
;   GOMEZ PC-SPEAKER DRIVER
;
;
;
DRV_TEXT 	equ 'PC-Speaker driver              ',0  ; 32 Bytes
DRV_VERSION     equ 1
DRV_NAME 	equ SPEAKER_Driver

;
EXTERNAL_ROUTINES MACRO
SpkrBaseTabla db 40h,40h,40h,40h,40h,40h,40h,40h,40h,40h,3Fh,3Fh,3Fh,3Fh
      db 3Fh,3Fh,3Fh,3Fh,3Fh,3Fh,3Fh,3Fh,3Eh,3Eh,3Eh,3Eh,3Eh,3Eh,3Eh,3Eh
      db 3Eh,3Eh,3Dh,3Dh,3Dh,3Dh,3Dh,3Dh,3Dh,3Dh,3Dh,3Ch,3Ch,3Ch,3Ch,3Ch
      db 3Ch,3Ch,3Ch,3Ch,3Ch,3Bh,3Bh,3Bh,3Bh,3Bh,3Bh,3Bh,3Bh,3Bh,3Bh,3Ah
      db 3Ah,3Ah,3Ah,3Ah,3Ah,3Ah,3Ah,3Ah,3Ah,39h,39h,39h,39h,39h,39h,39h
      db 39h,39h,39h,38h,38h,38h,38h,38h,38h,38h,38h,37h,37h,37h,37h,37h
      db 36h,36h,36h,36h,35h,35h,35h,35h,34h,34h,34h,33h,33h,32h,32h,31h
      db 31h,30h,30h,2Fh,2Eh,2Dh,2Ch,2Bh,2Ah,29h,28h,27h,26h,25h,24h,23h
      db 22h,21h,20h,1Fh,1Eh,1Dh,1Ch,1Bh,1Ah,19h,18h,17h,16h,15h,14h,13h
      db 12h,11h,11h,10h,10h,0Fh,0Fh,0Eh,0Eh,0Dh,0Dh,0Dh,0Ch,0Ch,0Ch,0Ch
      db 0Bh,0Bh,0Bh,0Bh,0Ah,0Ah,0Ah,0Ah,0Ah,09h,09h,09h,09h,09h,09h,09h
      db 09h,09h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,07h,07h
      db 07h,07h,07h,07h,07h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h
      db 05h,05h,05h,05h,05h,05h,05h,05h,05h,05h,04h,04h,04h,04h,04h,04h
      db 04h,04h,04h,04h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,02h,02h
      db 02h,02h,02h,02h,02h,02h,02h,01h,01h,01h,01h,01h,01h,01h,01h,01h
      db 01h,01h

SpkrTabla db 256 dup (0)
	ENDM
;
DRV_EXIT MACRO
	in      al,61h
	and     al,11111100b
	out     61h,al
	ENDM
;
VOICE_INIT MACRO		;in BX rate
	LOCAL 	L1
	push 	es
	push	esi
	push	edi

	mov 	ecx,256
	mov 	es,ds:[DATA32_Selector]
	mov 	edi,OFFSET SpkrTabla
	mov 	esi,OFFSET SpkrBaseTabla
L1:	lods 	byte ptr ds:[esi]
	xor 	ah,ah
	dec 	eax
	mov 	ebx,ds:[Timer_Constant]
	shr 	ebx,1
	mul 	ebx
	mov 	ebx,039h
	div 	ebx
	inc 	eax
	stosb
	loop 	L1

	pop	edi
	pop	esi
	pop 	es
	ENDM
;
VOICE_START MACRO
	in      al,61h
	or      al,3
	out     61h,al    ; Turn on speaker.

	mov     al,0b6h
	out     43h,al

	mov     al,0b0h
	out     43h,al
	mov     al,034h
	out     43h,al

	xor     al,al
	out     42h,al
	out     42h,al
	mov     al,10010000b
	out     43h,al    ; Select Speaker timer mode.

	mov 	eax,ds:[Timer_Constant]
	out 	40h,al
	shr 	eax,8
	out 	40h,al
	ENDM
;
VOICE_STOP MACRO
	in     	al,61h
	and    	al,11111100b
	out    	61h,al
	ENDM
;
VOICE_OUT MACRO
	push 	ebx
	mov    	ebx,OFFSET SpkrTabla
	xlat    ds:[ebx]
	out     42h,al
	pop 	ebx
     ENDM
;
include 	sndtimer.inc
CODE32 ENDS
END